import { Component, EventEmitter, Input, Output, OnInit } from '@angular/core';
import { ToastrService } from 'ngx-toastr';
export interface DataModel {
  code: string,
  behaviorIndicators: string[],
  assessmentTools: AssessmentToolsModal[][],
  curriculum: CurriculumModal[]
}
export interface AssessmentToolsModal {
  code: string,
  name: string,
  nameShow: string,
}
export interface CurriculumModal {
  code: string,
  name: string
}
@Component({
  selector: 'app-edit-group-indicators',
  templateUrl: './edit-group-indicators.html',
  styleUrls: ['./edit-group-indicators.scss']
})
export class EditGroupIndicators implements OnInit {
  @Output() sendEdit: EventEmitter<boolean> = new EventEmitter<boolean>();
  search = ""
  currentPage = 1
  page = Array.from({ length: 1 }, (_, i) => i + 1);
  dataList: DataModel[] = [
    {
      code: "1", behaviorIndicators: ["asdasdasdasdasdasdasdasdasdasddsdasdasdasdasdasdasdasdasdasdsad", "2", "3"], assessmentTools: [[
        { code: "O", nameShow: "O", name: "O" },
        { code: "A", nameShow: "A", name: "A" },
        { code: "D", nameShow: "D", name: "D" },
        { code: "O", nameShow: "O", name: "O" },
        { code: "A", nameShow: "A", name: "A" },
        { code: "D", nameShow: "D", name: "D" }
      ],[],[
        { code: "O", nameShow: "O", name: "O" },
      ]], curriculum: [{ code: "1", name: "1" }, { code: "asdasdasdasdasdasdasdasdasdasddsdasdasdasdasdasdasdasdasdasdsad", name: "asdasdasdasdasdasdasdasdasdasddsdasdasdasdasdasdasdasdasdasdsad" }, { code: "3", name: "3" }]
    },
    { code: "2", behaviorIndicators: [], assessmentTools: [], curriculum: [] },
    { code: "3", behaviorIndicators: [], assessmentTools: [], curriculum: [] }
  ]
  dataSelect?: DataModel
  assessmentToolsSelect: number = -1

  searchModal = ""
  currentPageModal = 1
  pageModal = Array.from({ length: 1 }, (_, i) => i + 1);

  assessmentToolsList: AssessmentToolsModal[] = [
    { code: "01", nameShow: "O", name: "แบบสังเกต" },
    { code: "02", nameShow: "D", name: "แบบการปฏิบัติงาน" },
    { code: "03", nameShow: "P", name: "การบันทึก/เอกสาร" },
    { code: "04", nameShow: "I", name: "การสัมภาษณ์" },
    { code: "05", nameShow: "T", name: "แบบทดสอบ" }
  ]


  curriculumList: CurriculumModal[] = [
    { code: "CC-01-01", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ O1-O2" },
    { code: "CC-01-02", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ O3-O4" },
    { code: "CC-01-03", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ S1-S2" },
    { code: "CC-01-04", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ S3-S4" },
    { code: "CC-01-05", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ M1-M2" },
    { code: "CC-01-06", name: "จิตสำนึกด้านความปลอดภัยและคุณภาพ (Safety & Quality) สำหรับพนักงานระดับ M3-M4" }
  ]


  ngOnInit() {
    this.searchChange()
  }
  onEdit() {
    this.sendEdit.emit(false);
  }
  searchChange() {
    this.currentPage = 1;
    const filteredData = this.dataListFilter();
    this.page = Array.from({ length: Math.ceil(filteredData.length / 10) }, (_, i) => i + 1);
  }
  dataListFilter() {
    return this.dataList.filter(x => {
      const match = x.code.includes(this.search);
      return match;
    });
  }

  assessmentToolsModalSearchChange() {
    this.currentPageModal = 1;
    const filteredData = this.assessmentToolsListFilter();
    this.pageModal = Array.from({ length: Math.ceil(filteredData.length / 10) }, (_, i) => i + 1);
  }
  assessmentToolsListFilter() {
    const dataList = (this.assessmentToolsSelect > -1 && this.dataSelect) ? this.dataSelect.assessmentTools[this.assessmentToolsSelect] : this.assessmentToolsList
    return dataList.filter(x => {
      const match = x.code.includes(this.searchModal) || x.name.includes(this.searchModal);
      return match;
    });
  }
  curriculumModalSearchChange() {
    this.currentPageModal = 1;
    const filteredData = this.curriculumListFilter();
    this.pageModal = Array.from({ length: Math.ceil(filteredData.length / 10) }, (_, i) => i + 1);
  }
  curriculumListFilter() {
    const dataList = this.curriculumList
    return dataList.filter(x => {
      const match = x.code.includes(this.searchModal) || x.name.includes(this.searchModal);
      return match;
    });
  }
}